package tests;

import input.Attribute;
import input.Class;
import input.Concrete;
import input.Keywords;
import input.Method;
import input.Parameter;
import input.Write;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Vector;

/**
 * classe de test pour la representation d'une classe.
 * et la generation du code pour le patron composite.
 * Utilise _ et $ comme parenthese
 * @author jroyer
  */
class TestGenerateAll {
	/**
	 * main.
	 * @param args classique
	 */
    public static void main(final String[] args) {
    	System.out.println("Generation du patron composite ...");
    	System.out.println("Quel type  (la classe existe ou connue de Java)");
    	System.out.println(" ?");
    	try {
			String type = new BufferedReader(new InputStreamReader(System.in)).readLine();
    	
		// repertoire de creation
		String dir = "output_int";
    	// Noms des elements du patron
    	String root = "List", base = "Empty", composite = "NotEmpty";
    	//ajustement des _type_
    	root += Keywords.IN + type + Keywords.OUT;
    	base += Keywords.IN + type + Keywords.OUT;
    	composite += Keywords.IN + type + Keywords.OUT;
    	
    	//-------------- auxillaires pour parametres
    	Vector<Parameter> pa = new Vector<Parameter>();
      	pa.add(new Parameter(root, "l"));
     	Vector<Parameter> ps = new Vector<Parameter>();
     	ps.add(new Parameter(type, "e"));
      	// ------------
        	
      	//============ root description
    	// les methodes
       	Vector<Method> beh = new Vector<Method>();
       	// isEmpty 
       	beh.add(new Method(Keywords.BOOLEAN, "isEmpty", 
       			Method.NOPARAMETER, "teste si empty ou pas"));
       	// length
       	beh.add(new Method(Keywords.INT, "length", 
       			Method.NOPARAMETER, "Calcule la longueur de la liste"));
      	// concatenation
      	beh.add(new Method(root, "append", pa, 
      		"Concatene deux listes"));
     	// to string
      	beh.add(new Method(Keywords.STRING, "toString",
      			Method.NOPARAMETER, "Conversion en chaine"));
     	// cons 
      	beh.add(new Concrete(composite, "cons", ps, 
          		"Insertion en tete de liste", 
          		"return new " + composite + "(e, this);"));
    	// putlast
      	beh.add(new Method(composite, "putlast", ps, 
      		"Ajout en fin de liste"));
    	// reverse
      	beh.add(new Method(root, "reverse", Method.NOPARAMETER, 
      		"Inversion d'une liste"));
       	// la classe
     	Class list = new Class(root, Class.NOATTRIBUTE, beh, false, "Object");
      	
     	// ecriture
     	Write g = new Write(dir, list);
     	g.write();
     	g.close();
     	
     	//================ base description
       	Vector<Method> beh1 = new Vector<Method>();
       	// isEmpty 
       	beh1.add(new Concrete(Keywords.BOOLEAN, "isEmpty", Method.NOPARAMETER, 
       			"teste si empty ou pas", "return true;"));
       	// length
      	beh1.add(new Concrete(Keywords.INT, "length", Method.NOPARAMETER, 
    			"Calcule la longueur de la liste", "return 0;"));
      	// concatenation 
      	beh1.add(new Concrete(root, "append", pa, 
          		"Concatene deux listes", "return l;"));
     	// to string
      	beh1.add(new Concrete(Keywords.STRING, "toString", Method.NOPARAMETER, 
          		"Conversion en chaine", "return \"\";"));
    	// putlast
      	beh1.add(new Concrete(composite, "putlast", ps, 
          		"Ajout en fin de liste", "return this.cons(e);"));
    	// reverse
      	beh1.add(new Concrete(base, "reverse", Method.NOPARAMETER, 
          		"Inversion d'une liste", "return this;"));
       	// la classe
     	Class empty = new Class(base, Class.NOATTRIBUTE, beh1, true, root);
      	
     	// ecriture
     	Write g1 = new Write(dir, empty);
     	g1.write();
     	g1.close();
     	
     	//==================== composite description
       	// les attributs
       	Vector<Attribute> att = new Vector<Attribute>();
       	att.add(new Attribute(type, "head"));
       	att.add(new Attribute(root, "tail"));
       	// les methodes
       	Vector<Method> beh2 = new Vector<Method>();
       	// isEmpty 
       	beh2.add(new Concrete(Keywords.BOOLEAN, "isEmpty", Method.NOPARAMETER, 
       			"teste si empty ou pas", "return false;"));
       	// length
       	beh2.add(new Concrete(Keywords.INT, "length", Method.NOPARAMETER, 
    			"Calcule la longueur de la liste", "return 1 + tail.length();"));
      	// concatenation 
      	beh2.add(new Concrete(composite, "append", pa, 
          		"Concatene deux listes", "return tail.append(l).cons(head);"));
     	// to string
      	beh2.add(new Concrete(Keywords.STRING, "toString", Method.NOPARAMETER, 
          		"Conversion en chaine", "return head + \" \" +tail.toString();"));
    	// putlast
      	beh2.add(new Concrete(composite, "putlast", ps, 
          		"Ajout en fin de liste", "return tail.putlast(e).cons(head);"));
    	// reverse
      	beh2.add(new Concrete(composite, "reverse", Method.NOPARAMETER, 
          		"Inversion d'une liste", "return tail.reverse().putlast(head);"));
       	// la classe
     	Class notempty = new Class(composite, att, beh2, true, root);
      	
     	// ecriture
     	Write g2 = new Write(dir, notempty);
     	g2.write();
     	g2.close();
     	
     	// ------ fin
    	System.out.println("TestGenerateAll :  generation du patron " + type + " finie!");
     	
		} catch (IOException e) {
			System.out.println("TestGenerateAll : probleme de lecture " + e);
	}
    }
}

	
